<?php
header("Content-Type: application/json");

 require_once 'users.php'; 

class RefreshTokenAPI {
    private $db;
    private $user;

    public function __construct() {
        $database = new Database();
        $this->db = $database->connect();
        $this->user = new User($this->db);
    }

    public function handleRequest() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            $this->refreshToken();
        } else {
            $this->respondNotFound();
        }
    }

    private function refreshToken() {
        $data = json_decode(file_get_contents("php://input"));

        // Validate refresh token presence
        if (empty($data->refresh_token)) {
            echo json_encode(["message" => "Refresh token required."]);
            return;
        }

        // Validate refresh token
        $user = $this->user->getUserByRefreshToken($data->refresh_token);

        if ($user) {
            // Generate new JWT token
            $token = JWT::createToken($user);

            echo json_encode([
                "message" => "Token refreshed successfully",
                "token" => $token
            ]);
        } else {
            echo json_encode(["message" => "Invalid refresh token."]);
        }
    }

    private function respondNotFound() {
        echo json_encode(["message" => "Invalid request"]);
    }
}

$api = new RefreshTokenAPI();
$api->handleRequest();
?>
