<?php
class User {
    private $conn;
    private $table = 'kum_user';
    private $Logtable = 'users_log';
    public $email;
    public $password;

    public function __construct($db) {
        $this->conn = $db;
    }

    // Check if email and password are correct
    public function login() {
        $query = "SELECT * FROM " . $this->table . " WHERE user_email = ? LIMIT 1";
        $stmt = $this->conn->prepare($query);
        $stmt->bind_param("s", $this->email);
        $stmt->execute();

        $result = $stmt->get_result();
        if ($result->num_rows > 0) {
            $user = $result->fetch_assoc();
            // Verify the password using password_verify
            if ($this->password==$user['user_password']) {
                return $user;  
            }
        }

        return false;  
    }
    
   public function saveRefreshToken($userId, $refreshToken) {
    // First, check if the record exists
    $checkQuery = "SELECT * FROM " . $this->Logtable . " WHERE user_id = ?";
    $stmt = $this->conn->prepare($checkQuery);
    $stmt->bind_param("i", $userId);
    $stmt->execute();
    $result = $stmt->get_result();

    if ($result->num_rows > 0) {
        // Record exists, so update it
        $query = "UPDATE " . $this->Logtable . " SET refresh_token = ? WHERE user_id = ?";
        $stmt = $this->conn->prepare($query);
        $stmt->bind_param("si", $refreshToken, $userId);
    } else {
        // Record does not exist, so insert a new one
        $query = "INSERT INTO " . $this->Logtable . " (user_id, refresh_token) VALUES (?, ?)";
        $stmt = $this->conn->prepare($query);
        $stmt->bind_param("is", $userId, $refreshToken);
    }

    return $stmt->execute();
}


    public function getUserByRefreshToken($refreshToken) {
        $query = "SELECT * FROM $this->$Logtable WHERE refresh_token = :refresh_token LIMIT 1";
        $stmt = $this->conn->prepare($query);
        $stmt->bindParam(':refresh_token', $refreshToken);

        $stmt->execute();

        if ($stmt->rowCount() > 0) {
            return $stmt->fetch(PDO::FETCH_ASSOC);
        }

        return false;
    }
}
?>
